﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"

Static StrConstant k_panelName = "imgT_panel"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"
Static StrConstant k_histGraphs = "imgT_histograms"
Static StrConstant k_imgDisplay = "imgT_display"
Static Constant gwidth = 640
Static StrConstant k_fullmqprofile = "imgT_display#imgT_panel#MQprofile"

// uncomment to debug
//#define DEBUG

#ifndef DEBUG
#pragma hide=1
#endif

// ***
// PANEL CONTROL FUNCTIONS

// tab procedure
Function X_TabProc(tca) : TabControl
	STRUCT WMTabControlAction &tca

	variable ctab
	string tablist, ptab
	
	switch( tca.eventCode )
		case 2: // mouse up
			ctab = tca.tab

#ifndef DEBUG
			// no switching to other tabs until an image is loaded
			if (!f_ImageLoaded())
				TabControl tab_main, win=$k_fullpanel, value = 0
				return 0
			endif
#endif
			// do nothing if the same tab
			ptab = GetUserData(k_fullpanel,"tab_main","ptab")
			if (str2num(ptab)==ctab)
				return 0
			endif
			
			// switch tabs
			disp_SwitchTab(ptab,ctab)
			
			break
	endswitch
	
	return 0
end

// button control procedure
Function X_ButtonProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba
	
	variable nimgs, brkout
	variable method, level, mask, stZ
	
	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			strswitch(ba.ctrlName)
				// control bar
				case "buttonResetIRange_CB":
					ChangeImageBitDepth(-1,0)
					ChangeImageBitDepth(1,1)
					Slider sliderIMin_CB, win=$k_imgDisplay, value=0
					Slider sliderIMax_CB, win=$k_imgDisplay, value=1
					disp_MoveHistCursor(0,0)
					break
				// tab M
				case "buttonImgL_tabM":
					disp_SetImageSide(0)
					break
				case "buttonImgR_tabM":
					disp_SetImageSide(1)
					break
				case "buttonleft_tabM":
					disp_SplitWindow(0)
					TM_StepThruImages(-1)	
					//disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					T3_UpdateContactPrint()
					break
				case "buttonright_tabM":
					disp_SplitWindow(0)
					TM_StepThruImages(1)
					//disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					T3_UpdateContactPrint()
					break
				case "buttonRedoH_tabM":
					disp_ShowHistograms(1)
					T3_UpdateContactPrint()
					//disp_UpdateTabM()
					DoWindow/F $k_histGraphs
					break
				// tab 0
				case "buttonLoad_tab0":
					nimgs = f_NImagesLoaded()
					ControlInfo/W=$k_fullpanel popupload_tab0
					switch(v_value)
						case 1:	// one file
							brkout = T0_LoadOneTIFFimg()
							break
						case 2:	// multiple files
							brkout = T0_LoadMultipleTIFFimgs()
							break
						case 3:	// a folder
							brkout = T0_LoadaFolder()
							break
						case 4:	// a stack
							brkout = T0_LoadStackTiffimgs()
							break
						case 5:	// internal data folder
							brkout = T0_ConvertDataFolders()
							break
					endswitch
					if (brkout == -1)
						return -1
					endif
					// replace image if this is the first
					if (nimgs == 0)
						TM_StepThruImages(0)
						T3_UpdateContactPrint()
						disp_InitializeTabMenus(100)
					else
						TM_StepThruImages(0)
						//disp_UpdatePanelControls(-1)
					endif
					ControlUpdate/A/W=$k_fullpanel
					break
				case "buttondoMovie_tabM":
					ControlInfo/W=$k_fullPanel setvarsleep_tabM
					TM_PlayStack(v_value)
					break
				// tab 1
				case "buttonSetXY_tab1":
					T1_SetXY()
					disp_UpdatePanelControls(1)
					break
				case "buttonclearlocalscale_tab1":
					T1_ClearXYScale(1)
					disp_UpdatePanelControls(1)
					break
				case "buttonclearglobalscale_tab1":
					T1_ClearXYScale(0)
					disp_UpdatePanelControls(1)
					break
				case "buttonSetcalI_tab1":
					T1_CalibrateIntensity()
					//disp_UpdatePanelControls(-1)
					disp_UpdatePanelControls(1)
					disp_UpdateHistograms()
					break
				case "buttonsetbckgrnd_tab1":
					ControlInfo/W=$k_fullPanel popupBckgHow_tab1
					T1_SetBackgroundPoints(v_value)
					break
				case "buttoneditbckpoints_tab1":
					T1_EditBackgroundPoints()
					break
				case "buttonclearbckpoints_tab1":
					T1_ClearBackgroundPoints()
					disp_UpdatePanelControls(1)
					break
				case "buttonRemoveBckg_tab1":
					T1_RemoveBackground()
					if (!f_IsBackground() && !f_IsSplit())
						T1_ShowBackground()
						disp_ShowHistograms(1)
						T3_UpdateContactPrint()
					endif
					disp_UpdatePanelControls(1)
					break
				case "buttonRestoreBckpoints_tab1":
					T1_RestoreBackgroundPoints()
					disp_UpdatePanelControls(1)
					break
				// tab 2
				case "buttondoThreshold_tab2":
					T2_StartThreshold()
					if (!f_IsThreshold() && !f_IsSplit())
						T2_ShowThreshold()
					endif
					//disp_UpdatePanelControls(-1)
					disp_UpdatePanelControls(2)
					break
				case "buttonFillThreshold_tab2":
					ControlInfo/W=$k_fullpanel popupThMask_tab2
					T2_FillThreshold(v_value)
					//disp_UpdatePanelControls(-1)
					disp_UpdatePanelControls(2)
					break
				case "buttonShowThStats_tab2":
					T2_ShowThesholdStats()
					break
				case "buttonDoMaskOP_tab2":
					T2_DoMaskOP(1)
					break
				// tab 3
				case "buttonRedoColor_tab3":
					disp_ShowScaleBar(0)
					ControlInfo/W=$k_fullpanel popupScaleBar_tab3
					if (v_value > 1)
						disp_ShowScaleBar(v_value-1)
						PopupMenu popupSBColor_tab3, win=$k_fullpanel, disable=0
						ControlInfo/W=$k_fullpanel popupSBColor_tab3
						disp_SetScaleBarColor(S_value)				
					endif
					break
				case "buttonDoCPrint_tab3":
					T3_CreateContactPrintLayout()
					break
				case "buttonClearAll_tab3":
					T3_ClearAllContactPrintImages()
					break
			endswitch
			disp_UpdatePanelControls(-1)
		case -1: // control being killed
			break
	endswitch
	
	return 0
end

// slider procedure
Function X_SliderProc(sa) : SliderControl
	STRUCT WMSliderAction &sa

	variable bd
	
	switch( sa.eventCode )
		case -3: // Control received keyboard focus
		case -2: // Control lost keyboard focus
		case -1: // Control being killed
			break
		default:
			strswitch(sa.ctrlName)
				case "slidermagdhist_tabM":
					if( sa.eventCode & 1 ) // value set
						ScaleDHistogram(sa.curval)
					endif
					break
				case "sliderIMin_CB":
					if( sa.eventCode & 1 ) // value set
						bd = ChangeImageBitDepth(-1,sa.curval)
						disp_MoveHistCursor(-1,bd)
					endif
					break
				case "sliderIMax_CB":
					if( sa.eventCode & 1 ) // value set
						bd = ChangeImageBitDepth(1,sa.curval)
						disp_MoveHistCursor(1,bd)
					endif
					break
			break
			endswitch
	endswitch

	return 0
end

// popmenu procedure
Function X_PopMenuProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			if (!X_PopHasChanged(pa))
				return 0
			endif
			strswitch(pa.ctrlName)
				// control bar
				case "popupSplit_CB":
					disp_SplitWindow(pa.popNum)
					break
				case "popupColor_CB":
					modifyimage $f_CurrentImage(), ctab={,,$pa.popStr,0}
					break
				// tab M
				case "popupFolder_tabM":
					// change to a new folder
					disp_SplitWindow(0)
					TM_StepThruImages(0)
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					T3_UpdateContactPrint()
					break
				case "popupFile_tabM":
					// change to a new file
					disp_SplitWindow(0)
					ResetImageFile(pa.popStr)
					TM_StepThruImages(0)
					disp_ResetImageFileonPanel()
					disp_UpdatePanelControls(-1)
					ControlInfo/W=$k_fullpanel tab_main
					disp_UpdatePanelControls(v_value)
					T3_UpdateContactPrint()
					break
				case "popupWhatInfo_tabM":
					disp_UpdateInfo(pa.popNum)
					break
				case "popupHistRoI_tabM":
					GenerateHistograms(pa.popNum-1)
					disp_UpdateTabM()
					break
				case "popupBitDepth_tabM":
					TM_RescaleBitDepth(pa.popNum)
					pa.userdata = ""
					disp_UpdateTabM()
					break
				// tab 0
				case "popupload_tab0":
					disp_UpdatePanelControls(0)
					break
				// tab 1
				case "popupmethodxy_tab1":
					T1_SetXYMethod(pa.popNum)
					disp_UpdatePanelControls(1)
					break
				case "popupmethodcalI_tab1":
					disp_UpdatePanelControls(1)
					break
				case "popupbckghow_tab1":
					T1_SetBckgrndHow(pa.popNum)
					break
				// tab 2
				case "popupThresMethod_tab2":
					ControlInfo/W=$k_fullpanel checkAutoThreshold_tab2
					if (v_value)
						T2_StartThreshold()
					endif
					disp_UpdatePanelControls(2)
					break
				case "popupThMask_tab2":
					ControlInfo/W=$k_fullpanel checkAutoThreshold_tab2
					if (v_value)
						T2_StartThreshold()
					endif
					disp_UpdatePanelControls(2)
					break
				case "popupThresOnPlane_tab2":
					ControlInfo/W=$k_fullpanel checkAutoThreshold_tab2
					if (v_value)
						T2_StartThreshold()
					endif
					disp_UpdatePanelControls(2)
					break
				case "popupMaskOPHow_tab2":
				case "popupMaskOPLevel_tab2":
					disp_UpdatePanelControls(2)
					break
				// tab 3
				case "popupSBColor_tab3":
					ControlInfo/W=$k_fullpanel popupScaleBar_tab3
					if (v_value > 1)
						disp_SetScaleBarColor(pa.popStr)
					else
						PopupMenu popupSBColor_tab3, win=$k_fullpanel, disable=2
					endif
					break
				case "popupScaleBar_tab3":
					disp_ShowScaleBar(pa.popNum - 1)
					if (pa.popNum > 1)
						PopupMenu popupSBColor_tab3, win=$k_fullpanel, disable=0
						ControlInfo/W=$k_fullpanel popupSBColor_tab3
						disp_SetScaleBarColor(S_value)				
					else
						PopupMenu popupSBColor_tab3, win=$k_fullpanel, disable=2
					endif
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end

// check whether popup has been changed
// uses userdata
// returns 1 when changed or 0 when not
Function X_PopHasChanged(pa)
	STRUCT WMPopupAction &pa
	
	if (cmpstr(pa.popStr,pa.userdata)==0)
		return 0
	else
		pa.userdata = pa.popStr
		return 1
	endif
end

// checkbox procedure
Function X_CheckProc(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up
			strswitch(cba.ctrlName)
				// control bar
				case "checkBW_CB":
					ChangeImageBitDepth(-2,cba.checked)
					break
				case "checkInvert_CB":
					ChangeImageBitDepth(0,cba.checked)
					break
				// tab M
				case "checklockhRoI_tabM":
					LockHistogramRoI(cba.checked)
					disp_SetHRoIControls(cba.checked)
					disp_UpdatePanelControls(-1)
					break
				case "checkshowhist_tabM":
					disp_ShowHideHistograms(!cba.checked)
					disp_UpdatePanelControls(-1)
					break
				// tab 1
				case "checkAsBackground_tab1":
					disp_UpdatePanelControls(1)
					break
				// tab 2
				case "checkAutoThreshold_tab2":
					if (cba.checked)
						T2_StartThreshold()
					endif
					disp_UpdatePanelControls(2)
					disp_UpdatePanelControls(-1)
					break
				// tab 3
				case "checkshowAxes_tab3":
					disp_ShowAxes(cba.checked)
					break
				case "checkCP_tab3":
					switch(cba.checked)
						case 0:
							T3_RemoveContactPrint()
							break
						case 1:
							T3_StoreasContactPrint()
							break
					endswitch
					T3_UpdateContactPrint()
					disp_UpdateTab3()
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch
	
	// return active state to panel
	DoWindow/F $k_panelName

	return 0
end

// set variable procedure
Function X_SetVarProc(sva) : SetVariableControl
	STRUCT WMSetVariableAction &sva

	// current only used to take notes to images
	switch( sva.eventCode )
		case 1: // mouse up
		case 2: // Enter key
		case 3: // Live update
			strswitch(sva.ctrlName)
				// control bar
				case "setvarimgMag_CB":
					Modifygraph/W=$k_imgDisplay expand=sva.dval
					//MoveWindow/W=$k_histgraphs 0,0,sva.dval*(gwidth+1),0.25*gwidth
					if (f_HasMQ())
						ResetMQCoordinates()
					endif
					break
				// tab M
				case "setvarSN_tabM":
					TM_StepThruImages(0,plane=sva.dval)
					T3_UpdateContactPrint()
					disp_UpdatePanelControls(-1)
					break
				case "setvarImgNote_tabM":
					TM_SetImageNote()
					break
				case "mqx0_tabM":
				case "mqy0_tabM":
				case "mqdx_tabM":
				case "mqdy_tabM":
					ResetMQCoordinates()
					break
				// tab 2
				case "setvarThresLevel_tab2":
					ControlInfo/W=$k_fullpanel checkAutoThreshold_tab2
					if (v_value)
						T2_StartThreshold()
					endif
					ControlInfo/W=$k_fullpanel popupThresMethod_tab2
					if (v_value == 1)
						string thlevels = StringFromList(1,SortList(TraceNameList(k_histgraphs,";",1)))
						Cursor/W=$k_histgraphs A, $thlevels, sva.dval				
					endif
					break
			endswitch
			break
		case -1: // control being killed
			break
	endswitch

	return 0
end

// put a date+time stamp
// [dsep] - in date; [tsep] - in time; [dtsep] - between date and time
Function/S f_DateTimeStamp([dsep, tsep, dtsep])
	string dsep, tsep, dtsep
 
	string a, b, c, dstr, tstr, gExp
 
	if (ParamIsDefault(dsep))
		dsep = "-"
	endif
	if (ParamIsDefault(tsep))
		tsep = ":"
	endif
	if (ParamIsDefault(dtsep))
		dtsep = "/"
	endif
 
	gExp = "([0-9]+):([0-9]+)"	
	SplitString/E=(gExp) secs2time(datetime,2), a, b
	tstr = a + tsep + b
 
	gExp = "([0-9]+)/([0-9]+)/([0-9]+)"	
	SplitString/E=(gExp) secs2date(datetime,-1), a, b, c
	dstr = c[2,3] + dsep + b + dsep + a
 
	return (dstr + dtsep +  tstr) 
end

// is the image window split?
Function f_IsSplit()
	
	GetAxis/W=$k_imgDisplay/Q splitT	
	return (!v_flag	)
end

// what is in the split window?
Function/S f_SplitWindowImage()

	string swstr = ""
	swstr = ImageNameList(k_imgDisplay,";")
	
	if (ItemsInList(swstr) > 1)
		swstr = StringFromList(1,SortList(swstr))
	else
		swstr = ""
	endif

	return swstr
end

// a threshold wave exists
Function f_ThresholdExists()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	if (f_isThreshold() == 1)
		return 1
	endif
	
	string thfile = cwfile + "_th"
	string wdf = "root:" + cwdfolder
	wave/SDFR=$wdf/Z thwave = $thfile
	return (waveexists(thwave))
end

// is this a threshold?
Function f_isThreshold()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwfile
	
	if (strsearch(cwfile,"_th",0)==-1)
		return 0
	else
		return 1
	endif
end

// is this a background?
Function f_isBackground()

	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwfile
	
	if (strsearch(cwfile,"_bg",0)==-1)
		return 0
	else
		return 1
	endif
end

// is an image loaded?
Function f_ImageLoaded()

	string st = f_LoFolders(cstr="imgT_*")

	if (strlen(st)==0)
		return 0
	else
		return 1
	endif
end
//
//// does the inverted image exist?
//Function f_InvertedExists()
//
//	// globals	
//	DFREF pf = $k_fullpackageFolder
//	SVAR/SDFR=pf cwdfolder, cwfile
//
//	variable itExists = 0
//	
//	string wdf = "root:" + cwdfolder
//	string itsInverted = wdf + ":" + cwfile + "_inv"
//	
//	wave/Z/SDFR=$wdf iwave = $itsInverted
//	if (WaveExists(iwave))
//		itExists = 1
//	endif
//	
//	return itExists
//end

// return string for working data folder or image name
Function/S f_wdfstr(variable which)

	// globals
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	string wdf = "root:" + cwdfolder
	switch(which)
		case 1:
			wdf += ":" + cwfile
			break
	endswitch
	
	return wdf
end

// return wave reference to image being displayed
Function/WAVE f_imgwaveDisplayed()

	string wdf = f_wdfstr(0)
	string ifile = f_wdfstr(1)
	
	wave/SDFR=$wdf wref = $ifile

	return wref
end

// image id information
// 0 - cwdfolder + cwfile + : plane number
// 1 - cwdfolder
// 2 - cwfile
// 3 - full path to source
Function/S f_DisplayImageID(how)
	variable how

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string rfile
	switch(how)
		case 0:
			rfile = cwdfolder + ":" + cwfile + ":" + num2str(f_PlaneNumber())
			break
		case 1:
			rfile = cwdfolder
			break
		case 2:
			rfile = cwfile
			break
		case 3:
			rfile = "root:" + cwdfolder + ":" + cwfile
			break
	endswitch
	return rfile
end

//// root file name
//Function/S f_RootFileName()
//
//	// globals for package	
//	DFREF pf = $k_fullpackageFolder
//	SVAR/SDFR=pf cwdfolder, cwfile
//
//	string rfile
//	
//	rfile = ReplaceString("_th",cwfile,"")
//	rfile = ReplaceString("_bg",rfile,"")
//	
//	return rfile	
//end

// number of image sets loaded
Function f_NImagesLoaded()

	variable ni
	ni = ItemsInList(f_LoImgT())
	return ni
end

// options to show in split window
Function/S f_SplitOptions()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string mStr = "None;"
	string wdf = "root:" + cwdfolder
	
	string hide = "\\M1(", hideT = "", hideB = ""
	
	string tfile, bfile
	
	if (f_IsThreshold())
		tfile = cwfile
		hideT = hide
	else
		tfile = cwfile + "_th"
	endif
	if (f_IsBackground())
		bfile = cwfile
		hideB = hide
	else
		bfile = cwfile + "_bg"
	endif
	
	wave/SDFR=$wdf/Z twave = $tfile
	if (waveexists(twave))
		mStr += hideT + "Threshold;"
	else
		mStr += hide + "Threshold;"
	endif
	wave/SDFR=$wdf/Z bwave = $bfile
	if (waveexists(bwave))
		mStr += hideB + "Background;"
	else
		mStr += hide + "Background;"
	endif		
	
	return mStr
end
//
//// current image is normalized
//Function f_isNormalized()
//
//	string cimg = f_wdfStr(1)
//	variable rtnv = 0
//	
//	if (StringMatch(cimg,"*_nb*") > 0)
//		rtnv = 1
//	endif
//	
//	return rtnv
//
//end

// current file is stack
Function f_isStack()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string imgFile = "root:" + cwdfolder + ":" + cwfile
	variable rtnv = 0
	
	if (DimSize($imgFile,2)>0)
		rtnv = 1
	endif
	
	return rtnv
end

// number of images in stack
Function f_NImagesinStack()

	// globals for package	
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable ni
	string imgFile = "root:" + cwdfolder + ":" + cwfile
	
	ni = DimSize($imgFile,2)
	if (numtype(ni)!=0)
		ni = 0
	endif
	return ni
end

// current plane number being viewed in stack
Function f_PlaneNumber()

	variable pl = 0
	string info, plstr
	
	if (f_isStack())
		info = ImageInfo(k_imgDisplay,"",0)
		plstr = StringByKey("plane", info,"=")
		pl = str2num(plstr)
	endif
	
	return pl
end

// list of imgT folders
Function/S f_LoImgT()

	DFREF cdf = GetDataFolderDFR()

	SetDataFolder root:
	string lof = f_LoFolders(cstr="imgT_*")
	SetDataFolder cdf
	
	lof = ReplaceString("imgT_",lof,"")
	
	return lof
end

// return the image note for the current display
Function/S f_ImageNoteText()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	string wname = "root:" + cwdfolder + ":" + cwfile
	
	return (note($wname))
end

// image size
// 0 - method
// 1 - width (pixels)
// 2 - height (pixels)
// 3 - width (meters)
// 4 - height (meters)
// 5 - meters/pixel
Function/WAVE f_ImageSize()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	variable xpixels, ypixels
	
	string wname = "root:" + cwdfolder + ":" + cwfile
	xpixels = DimSize($wname,0)
	ypixels = DimSize($wname,1)
	
	make/N=6/FREE/D rwave
	rwave[1] = xpixels
	rwave[2] = ypixels

	// check for scale for image
	STRUCT S_CalibrateVariables scv
	// pixels (no local or global scaling)
	if (Sf_RecallCalibrateVariables(scv)==-1)
		rwave[0] = 0
		rwave[3] = NaN
		rwave[4] = NaN
		rwave[5] = NaN
		return rwave
	endif
	
	rwave[0] = scv.xyhow
	rwave[3] = scv.xyiwidth
	rwave[4] = scv.xyiheight
	rwave[5] = scv.mpp

	return rwave
end

// return the image size for the current display
Function/S f_ImageSizeText()

	variable xcal = f_ImageSize()[0]
	string rtstr = ""
	
	switch(xcal)
		case 0:		// no scaling
			sprintf rtstr, "%d x %d [pixels]", f_ImageSize()[1], f_ImageSize()[2]
			break
		default:
			sprintf rtstr, "%.3e x %.3e [m]", f_ImageSize()[3], f_ImageSize()[4]
			break
	endswitch
	
	return rtstr
end

// background image information
Function/S f_BcktoStackOptions()

	string rstr = "separate;keep as stack;"
	
	if (f_BckgImageSet())
		rstr += "to all stack;"
	endif

	return rstr
end

Function f_BckgImageSet()

	ControlInfo/W=$k_fullpanel checkAsBackground_tab1
	return (v_value)
end

// list of threshold mask methods
Function/S f_TMasks()

	string rtstr = "None;"
	
	STRUCT S_MarqueeCoordinates mq
	Sf_GetMQCoordinates(mq)

	if (mq.hasmarquee == 1)
		rtstr += ".X.<[ ]>.X.; [>.X.<] ;"
	endif
	
	return rtstr
end

// list of Background RoI methods
Function/S f_BckgRoIs()

	string rtstr = "Set Marquee First;"
	
	STRUCT S_MarqueeCoordinates mq
	Sf_GetMQCoordinates(mq)

	if (mq.hasmarquee == 1)
		rtstr = ".B.<[ ]>.B.; [>.B.<] ;"
	endif
	
	return rtstr
end

// return maximum value of current displayed image
Function f_DisplayedImageMax()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable rtn, cplane
	string iname
	
	iname = "root:" + cwdfolder + ":" + cwfile
	wave cdimg = $iname
	
	if (f_IsStack())
		MatrixOP/FREE cdfimg = cdimg[][][cplane]
		rtn = wavemax(cdfimg)
	else
		rtn = wavemax(cdimg)
	endif
	
	return rtn
end

// return the bit depth of the current image
Function f_ImageBitDepth([simgname])
	string simgname

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable bitd, wtype
	string wname = ""
	
	if (!ParamIsDefault(simgname))
		wname = simgname
	else
		wname = "root:" + cwdfolder + ":" + cwfile
	endif
	wtype = WaveType($wname,0)
	
	if (wtype & 2)		// 32 bit float
		bitd = 32
	elseif (wtype & 4)	// 64 bit float
		bitd = 64
	elseif (wtype & 0x08)
		bitd = 8		// 8 bit
	elseif (wtype & 0x10)
		bitd = 16		// 16 bit
	endif
	
	return bitd
end

// list of folders in a sdfr following a cstr string convention
Function/S f_LoFolders([sdfr,cstr])
	string cstr
	DFREF sdfr
	
	if (!ParamIsDefault(sdfr))
		SetDataFolder sdfr
	endif
	
	string tstr = "", lstr = ""
	variable ic
	do
		tstr = GetIndexedObjName("",4,ic)
		if (strlen(tstr)==0)
			break
		else
			lstr += tstr + ";"
		endif
		ic += 1
	while (1)
	
	if (!ParamIsDefault(cstr))
		lstr = ListMatch(lstr,cstr,";")
	endif
	
	return lstr
end

// image files in a given folder
Function/S f_LoimgF([sfolder])
	string sfolder
	
	string lfiles = ""
	
	if (!ParamIsDefault(sfolder))
		lfiles = "root:" + sfolder
	else
		ControlInfo/W=$k_fullpanel popupfolder_tabM
		lfiles = "root:imgT_" + S_value
	endif
	
	DFREF imgF = $lfiles
	DFREF cdf = GetDataFolderDFR()
	SetDataFolder imgF
	lfiles = ReplaceString("img_",WaveList("img_*",";",""),"")
	SetDataFolder cdf
	
	return lfiles
end

// has XY scale
// 0 - global, 1 - local
Function f_HasXYScale(where)
	variable where
	
	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder
	string wf

	switch(where)
		case 0:		// global
			wf = k_fullpackageFolder + ":imgT_processvariables"	
			break
		case 1:		// local
			wf = "root:" + cwdfolder + ":imgT_processvariables"	
			break
	endswitch
	if (DataFolderExists(wf))
		return 1
	else
		return 0
	endif
end

// checks whether the current image is already a contact print storage
Function f_IsContactPrint()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable tf=0, ic=0, cplane = f_isStack() ? f_PlaneNumber() : 0
	string cpstr,cpritem
	
	if (f_CountofContactPrints()==0)
		return tf
	endif
	
	cpstr = cwdfolder[5,inf] +"_" + cwfile
	if (f_isStack())
	 cpstr += "_" + num2str(f_PlaneNumber())
	endif
	
	do
		cpritem = GetIndexedObjNameDFR(cpf,3,ic)
		if (strlen(cpritem)==0)
			break
		endif
		if (cmpstr(cpstr,cpritem)==0)
			tf = 1
			break
		endif
		ic += 1
	while(1)

	return tf
end

// counts the number of contact prints stored
Function f_CountofContactPrints()

	// global values
	DFREF cpf = $k_fullpackageFolder + ":contactprint"
	
	variable cnt = 0
	
	if (DataFolderExists(k_fullpackageFolder + ":contactprint"))
		cnt = CountObjectsDFR(cpf,3)
	else
		cnt = -1
	endif
	
	return cnt
end

// image RGB setting
Function f_imgRGB([thisimg])
	wave thisimg

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile

	variable iRGB=0
	
	if (ParamIsDefault(thisimg))
		string wname = "root:" + cwdfolder + ":" + cwfile
		wave wimg = $wname
	else
		wave wimg = thisimg
	endif
	if (WaveDims(wimg)	 == 3)
		iRGB = 1
	endif
	return iRGB
end

// string to return list of Histogram options
Function/S f_LoInfoOptions()

	string rtnstr = "None;Histograms;"
	
	if ((f_HasHRoI() > 0) || (f_HasMQ() > 0))
		
		//rtnstr += "Profiles;"
	endif
	
	return rtnstr
end

// string to return list of Histogram options
Function/S f_LoHMRoI()

	string rtnstr = "None;"
	
	if ((f_HasHRoI() > 0) || (f_HasMQ() > 0))		
		rtnstr += ".O.<[ ]>.O.;[>.I.<];.O.<[ ]>.O. - [>.I.<];[>.I.<] - .O.<[ ]>.O.;"
	endif
	
	return rtnstr
end

// has background marker wave
Function f_HasBckgMrkrs()

	variable hasmarker = 0
	string imgList = TraceNameList(k_imgDisplay,";",1)
	if (FindListItem("imgT_bckgY",imgList) >= 0)
		hasmarker = 1
	endif
	
	return hasmarker
end

Function f_HasStoredBckgrnd()

	variable hassb = 0
	
	string cwdfstr = f_DisplayImageID(1)
	DFREF cwdf = $cwdfstr
	
	string bstr = "root:" + cwdfstr + ":imgT_background"
	
	if (DataFolderExists(bstr))
		hassb = 1
	endif
	
	return hassb

end

// has global background markers stored
Function f_HasGlobalBckgMrkrs()

	// global values
//	DFREF pf = $k_fullpackageFolder

	variable hasmarker = 0
	string imgList = TraceNameList(k_imgDisplay,";",1)
	if (FindListItem("imgT_bckgY",imgList) < 0)
		hasmarker = 0
	else
		hasmarker = 1
	endif
	
	return hasmarker
end

// has marquee or locked marquee
Function f_HasMQ()

	GetMarquee/W=$k_imgDisplay/Z
	return (v_flag)
end

// has histogram drawing RoI
Function f_HasHRoI()

	DrawAction/W=$k_imgDisplay/L=ProgFront getgroup=hRoI, extractOutline
	return (v_flag)
end

// what is the current image?
Function/S f_CurrentImage()
	
	string cImage = ImageNameList(k_imgDisplay,"")
	cImage = ListMatch(cImage,"!RP_*")
	cImage = StringFromList(0,SortList(cImage))
	return cImage
end

// delta of cursors: 1-dx, 2-dx in m, 3-dy
Function f_MQCursorDelta(how)
	variable how

	variable vrtn
	string cstr
	
	return 0
	
	switch(how)
		case 0:		// dx		
			cstr = CsrInfo(B,k_fullmqprofile)
			vrtn = NumberByKey("POINT",cstr)
			cstr = CsrInfo(A,k_fullmqprofile)
			vrtn -= NumberByKey("POINT",cstr)
			break
		case 1:		// dx m	
			cstr = CsrInfo(B,k_fullmqprofile)
			vrtn = NumberByKey("POINT",cstr)
			cstr = CsrInfo(A,k_fullmqprofile)
			vrtn -= NumberByKey("POINT",cstr)
			vrtn *= f_ImageSize()[5]
			break
		case 2:		// dy
			vrtn = vcsr(B,k_fullmqprofile)
			vrtn -= vcsr(A,k_fullmqprofile)
			break
	endswitch
	
	return vrtn
end

Function f_StackOKtoThreshold()

	// global values
	DFREF pf = $k_fullpackageFolder
	SVAR/SDFR=pf cwdfolder, cwfile
	
	variable rtnv = 1
	string bfile, sfile, sfldr
	
	if (f_IsBackground())
		bfile = ReplaceString("_th",cwfile,"")
		sfldr = "root:" + cwdfolder
		wave/SDFR=$sfldr bimg = $bfile
		Make/N=(f_NImagesinStack())/FREE iMaxValues
		MultiThread iMaxValues = f_GetPlaneMax(bimg,p)
		iMaxValues = iMaxValues[p] == 0 ? NaN : iMaxValues[p]
		WaveStats/M=1/Q iMaxValues
		if (V_numNaNs > 0)
			rtnv = 0
		endif
	endif
	
	return rtnv
	
end

ThreadSafe Function f_GetPlaneMax(ww,pp)
	wave ww
	variable pp
	
	MatrixOP/FREE maxvalpp = maxVal(layer(ww,pp))
		
	return maxvalpp[0]
end

// raw image?
Function f_IsRawImage()

	variable vrtn = 1, ic = 0
	
	string cwf = f_DisplayImageID(2)
	string exlist = "*_th*;*_bg*;*_nbh*;*_nbf*;*_msk*;"
	
	for(ic=0;ic<5;ic+=1)
		if (StringMatch(cwf,StringFromList(ic,exlist)) == 1)
			vrtn = 0
			break
		endif
	endfor
	
	return vrtn
end

// bit depth controls
Function/S f_LoBitDepths()

	string rstr = ""
	variable bd = f_ImageBitDepth()
	
	if (f_IsRawImage())
		rstr = "\\M1(8;\\M1(16;\\M1(32;\\M1(64;"
	else
		switch(bd)
			case 8:
				rstr = "\\M1(8;16;32;64;"
				break
			case 16:
				rstr = "\\M1(8;\\M1(16;32;64;"
				break
			case 32:
				rstr = "\\M1(8;\\M1(16;\\M1(32;64;"
				break
			case 64:
				rstr = "\\M1(8;\\M1(16;\\M1(32;\\M1(64;"
				break
		endswitch
	endif
	
	return rstr
end

Function f_PBitDepth()

	variable bd = f_ImageBitDepth()
	variable rtnv = 1
	
	switch(bd)
		case 16:
			rtnv = 2;
			break
		case 32:
			rtnv = 3;
			break
		case 64:
			rtnv = 4;
			break
	endswitch
	
	return rtnv
end
