﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Static StrConstant k_fullpackageFolder = "root:Packages:imgT"
Static StrConstant k_fullpanel = "imgT_display#imgT_panel"

// uncomment to debug
//#define DEBUG

#pragma hide = 1

// ***
// STRUCTURES

// structure to collect load instructions
Structure S_LoadSettings
	variable what
	variable source
	variable allow16bit
	variable red
	variable green
	variable blue
	variable gray
	variable graw
	variable howmany
	variable channels
	variable startimage
	variable stepimage
	variable endimage
	variable startindex
	variable stepindex
	variable asstack
EndStructure

// populate the structure
Function Sf_GetLoadSettings(ls)
	STRUCT S_LoadSettings &ls

	// load what?
	ControlInfo/W=$k_fullpanel popupload_tab0
	ls.what = v_value
	
	// what type of image?
	ControlInfo/W=$k_fullpanel checkgraw_tab0
	ls.graw = v_value
	
	// extract what?
	ControlInfo/W=$k_fullpanel checkgred_tab0
	ls.red = v_value
	ControlInfo/W=$k_fullpanel checkggreen_tab0
	ls.green = v_value
	ControlInfo/W=$k_fullpanel checkgblue_tab0
	ls.blue = v_value
	ControlInfo/W=$k_fullpanel checkggray_tab0
	ls.gray = v_value
	
	// how many?
	ls.howmany = ls.graw + ls.red + ls.green + ls.blue + ls.gray
	if (ls.howmany > 0)
		if (ls.graw)
			ls.channels = 1
		else
			ls.channels = 3
		endif
	else
		ls.channels = 0
	endif
	
	// processing?
	ControlInfo/W=$k_fullpanel checkgsource_tab0
	ls.source = v_value	
	ControlInfo/W=$k_fullpanel checkallow16bit_tab0
	ls.allow16bit = v_value
	
	ControlInfo/W=$k_fullpanel startimg_tab0
	ls.startimage = v_value
	ControlInfo/W=$k_fullpanel endimg_tab0
	ls.endimage = v_value
	ControlInfo/W=$k_fullpanel stepimg_tab0
	ls.stepimage = v_value
	ControlInfo/W=$k_fullpanel startind_tab0
	ls.startindex = v_value
	ControlInfo/W=$k_fullpanel stepind_tab0
	ls.stepindex = v_value
	
	ControlInfo/W=$k_fullpanel checkasstack_tab0
	ls.asstack = v_value
	
	return 0
end

// draw tab0 - load
Function disp_Tab0Draw(pwidth,pheight,ptabpos)
	variable pwidth, pheight, ptabpos

	variable tvoffset = ptabpos+30
	
	TabControl tab_main, value=0, userdata(ptab)="0"
	
	TitleBox load_tab0,pos={12,tvoffset},size={84,22},title="Load Image(s)"
	TitleBox load_tab0,fSize=16,frame=0,fStyle=1,disable=0

	tvoffset += 25
	
	PopupMenu popupload_tab0,pos={22,tvoffset},size={113,23},title="What"
	PopupMenu popupload_tab0,mode=1,popvalue="One File",value= #"\"One File;Many Files;Entire Folder;Image Stack;Internal Data Folder;\""
	PopupMenu popupload_tab0,disable=0,proc=X_PopMenuProc
	
	CheckBox checkasstack_tab0, pos={pwidth-120,tvoffset-2}, title="store as stack"
	CheckBox checkasstack_tab0, value=0, disable=2
	CheckBox checkasstack_tab0, help={"Load N>4 files as stack or load a stack as a stack"}

	tvoffset += 25
	
	SetVariable startimg_tab0, pos={25,tvoffset},size={120,16},title="Start At"
	SetVariable startimg_tab0, value=_NUM:1, limits={0,inf,1}, disable=2
	SetVariable endimg_tab0, pos={25+130,tvoffset},size={120,16},title="Load Only"
	SetVariable endimg_tab0, value=_NUM:inf, limits={1,inf,1}, disable=2
	SetVariable stepimg_tab0, pos={25+260,tvoffset},size={120,16},title="Step By"
	SetVariable stepimg_tab0, value=_NUM:1, limits={1,inf,1}, disable=2
	
	tvoffset += 20
	
	SetVariable startind_tab0, pos={25,tvoffset},size={120,16},title="Start Label"
	SetVariable startind_tab0, value=_NUM:0, limits={0,inf,1}, disable=2
	SetVariable stepind_tab0, pos={25+130,tvoffset},size={120,16},title="Step Label"
	SetVariable stepind_tab0, value=_NUM:1, limits={1,inf,1}, disable=2
	
	tvoffset +=25
	
	CheckBox checkgsource_tab0,pos={30,tvoffset},size={76,16},title="keep source"
	CheckBox checkgsource_tab0,value=0, proc=X_SetLoad
	
	CheckBox checkallow16bit_tab0,pos={30,tvoffset+15},size={76,16},title="allow 16+ bit",value=0
	
	CheckBox checkgred_tab0,pos={35+100,tvoffset},size={102,16},title="extract red channel"
	CheckBox checkgred_tab0,value=0,proc=X_SetLoad
	CheckBox checkggreen_tab0,pos={35+100,tvoffset+15},size={114,16},title="extract green channel"
	CheckBox checkggreen_tab0,value=0,proc=X_SetLoad
	CheckBox checkgblue_tab0,pos={35+100,tvoffset+30},size={107,16},title="extract blue channel"
	CheckBox checkgblue_tab0,value=0,proc=X_SetLoad	
	CheckBox checkgGray_tab0,pos={35+100,tvoffset+45},size={109,16},title="generate grayscale"
	CheckBox checkgGray_tab0,value=0,proc=X_SetLoad

	CheckBox checkgraw_tab0,pos={35+250,tvoffset},size={109,16},title="single channel (gray)"
	CheckBox checkgraw_tab0,value=0,proc=X_SetLoad
	
	tvoffset += 35
	
	Button buttonLoad_tab0,pos={300,tvoffset},size={80,25},proc=X_ButtonProc,title="Load"
	Button buttonLoad_tab0,disable=2

	return 0
end

// update tab 0
Function disp_UpdateTab0()
	
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)
	
	variable conv = 0
	// not a stack
	SetVariable/Z startimg_tab0, win=$k_fullpanel, disable=1
	SetVariable/Z stepimg_tab0, win=$k_fullpanel, disable=1
	SetVariable/Z endimg_tab0, win=$k_fullpanel, disable=1
	SetVariable/Z startind_tab0, win=$k_fullpanel, disable=1
	SetVariable/Z stepind_tab0, win=$k_fullpanel, disable=1
	// all options open
	Checkbox checkgsource_tab0, win=$k_fullpanel, disable=0
	Checkbox checkallow16bit_tab0, win=$k_fullpanel, disable=0
	Checkbox checkgred_tab0, win=$k_fullpanel, disable=0
	Checkbox checkggreen_tab0, win=$k_fullpanel, disable=0
	Checkbox checkgblue_tab0, win=$k_fullpanel, disable=0
	Checkbox checkggray_tab0, win=$k_fullpanel, disable=0
	Checkbox checkgraw_tab0, win=$k_fullpanel, disable=0
	CheckBox checkasstack_tab0, win=$k_fullpanel, disable=0
	
	// what is to be loaded
	switch(ls.what)
		case 5:	// convert
			Checkbox checkgsource_tab0, win=$k_fullpanel, disable=1
			Checkbox checkallow16bit_tab0, win=$k_fullpanel, disable=1
			Checkbox checkgred_tab0, win=$k_fullpanel, disable=1
			Checkbox checkggreen_tab0, win=$k_fullpanel, disable=1
			Checkbox checkgblue_tab0, win=$k_fullpanel, disable=1
			Checkbox checkggray_tab0, win=$k_fullpanel, disable=1
			Checkbox checkgraw_tab0, win=$k_fullpanel, disable=1
			conv = 1
			break
		case 4:	// load stack
			SetVariable/Z startimg_tab0, win=$k_fullpanel, disable=0
			SetVariable/Z stepimg_tab0, win=$k_fullpanel, disable=0
			SetVariable/Z endimg_tab0, win=$k_fullpanel, disable=0
			SetVariable/Z startind_tab0, win=$k_fullpanel, disable=0
			SetVariable/Z stepind_tab0, win=$k_fullpanel, disable=0
			break
		case 1:	// load only one
			CheckBox checkasstack_tab0, win=$k_fullpanel, disable=1, value=0
			break
	endswitch
	
	if (conv)
		Button buttonLoad_tab0, win=$k_fullpanel, title="Convert", userData="Convert", disable=0
	else
		if (ls.graw)
			Checkbox checkgred_tab0, win=$k_fullpanel, disable=2, value=0
			Checkbox checkggreen_tab0, win=$k_fullpanel, disable=2, value=0
			Checkbox checkgblue_tab0, win=$k_fullpanel, disable=2, value=0
			Checkbox checkggray_tab0, win=$k_fullpanel, disable=2, value=0
		else
			Checkbox checkgred_tab0, win=$k_fullpanel, disable=0, value=0
			Checkbox checkggreen_tab0, win=$k_fullpanel, disable=0, value=0
			Checkbox checkgblue_tab0, win=$k_fullpanel, disable=0, value=0
			Checkbox checkggray_tab0, win=$k_fullpanel, disable=0, value=0
			Checkbox checkgraw_tab0, win=$k_fullpanel, disable=0
		endif
		
		if (ls.howmany == 0)
			Button buttonLoad_tab0, win=$k_fullpanel, title="Load", userData="Load", disable=2
		else
			Button buttonLoad_tab0, win=$k_fullpanel, title="Load", userData="Load", disable=0
		endif
	endif
	
	return 0
end


// load a single TIFF image
Function T0_LoadOneTIFFImg()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	string theFolder = ""
	variable ic
	
	SetDataFolder root:
	
	// select file	
	string fFilter = "TIF Images ONLY:.tif,.tiff;"
	variable refNum
	Open/D/R/F=fFilter/M="Select ONE TIFF image" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	// get path and file name
	string fPath, fFullName, fnsuffix, fnimg
	fPath = ParseFilePath(1,S_filename,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	
	// load the image file
	fFullName = ParseFilePath(0,S_filename,":",1,0)
	theFolder = T0do_loadfile(fFullName,ls)
		
	SetDataFolder root:
	
	fFilter = f_DateTimeStamp() + " -> Loaded one TIFF image file from " + fPath
	fFilter += "\r\tFile: " + fFullName
	fFilter += "\r\tInto Folder: " + theFolder
	print fFilter
	
	return 0
end

Function T0_CleanUpTags()
	
	string fList, theTagFldr
	variable ic,nitems
	
	fList = DataFolderDir(1)
	fList = ReplaceString("FOLDERS:",fList,"")
	nitems = ItemsInList(fList,",")
	NewDataFolder/O imgT_tags
	for(ic=0;ic<nitems;ic+=1)
		theTagFldr = StringFromList(ic,fList,",")
		if (stringmatch(theTagFldr,"Tag*") == 1)
			MoveDataFolder/O=1 $theTagFldr imgT_tags
		endif
	endfor

	return 0
end

// load a set of TIFF images
Function T0_LoadMultipleTIFFImgs()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;", pstr
	string fPath, fFullName, theFile, fList="", thefList = "", fnsuffix, fnimg	
	string FolderNameList = "", theFP = "", as = ""
	variable refNum, ic, nf
	
	// select files
	Open/MULT=1/D/R/F=fFilter/M="Select multiple TIFF images" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	fList = ReplaceString("\r",S_filename,";")
	fList = SortList(fList)
	
	// get path and file names	
	theFile = StringFromList(0,fList)
	fPath = ParseFilePath(1,theFile,":",1,0)
	NewPath/O/Q/Z imgPath, fPath
	theFP = ParseFilePath(0,theFile,":",1,1)
	
	SetDataFolder root:

	// load multiple files as stack			
	nf = ItemsInLIst(fList)	
	if ((ls.asstack == 1) && (nf > 4))
		as = " as stack"
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,fList)
			thefList += ParseFilePath(0,theFile,":",1,0) + ";"
		endfor
		FolderNameList = T0do_loadfilesasstack(theFP,thefList,ls)
	else
		// loop through to load files
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,fList)
			fFullName = ParseFilePath(0,theFile,":",1,0)
			FolderNameList += T0do_loadfile(fFullName,ls)
			thefList += fFullName + ";"
		endfor
	endif
	
	SetDataFolder root:
	
	pstr = f_DateTimeStamp() + " -> Loaded multiple TIFF image files from " + fPath
	pstr += "\r\tFiles: " + thefList
	pstr += "\r\tInto Folders: " + FolderNameList + as
	print pstr
		
	return 0
end

// load a folder of TIFF images
Function T0_LoadaFolder()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	variable ic, nf
	string flist, fPath, theFile, thefList, fFullName, FolderNameList = ""
	string pstr, theFP, as = ""
	
	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	// select folder
	NewPath/O/Q/M="Select a folder with the TIF images"/Z imgPath
	if (v_flag!=0)
		return -1
	endif
	
	// load the folder
	PathInfo imgPath
	fPath = ParseFilePath(0,S_path,":",1,0)
	flist = IndexedFile(imgPath,-1,".tif")
	flist = SortList(flist)
	theFP = ParseFilePath(0,S_path,":",1,1)

	nf = ItemsInList(flist,";")
	
	// load folder as stack			
	if ((ls.asstack == 1) && (nf > 4))
		as = " as stack"
		FolderNameList = T0do_loadfilesasstack(fPath,flist,ls)
	else
		if (ls.asstack == 1)
			DoAlert/T="Loading Files" 0, "Fewer than 4 files in folder will be loaded separateley"
		endif
		// loop through to load files
		for (ic=0;ic<nf;ic+=1)
			theFile = StringFromList(ic,flist)
			FolderNameList += T0do_loadfile(theFile,ls) + ";"
		endfor
	endif

	SetDataFolder root:
	
	pstr = f_DateTimeStamp() + " -> Loaded a folder of TIFF image files from " + fPath
	pstr += "\r\tFiles: " + flist
	pstr += "\r\tInto Folders: " + FolderNameList + as
	print pstr

	return 0
end

// load a stack of TIFF images
Function T0_LoadStackTIFFImgs()
	
	// get load settings
	STRUCT S_LoadSettings ls
	Sf_GetLoadSettings(ls)

	if (ls.howmany == 0)
		DoAlert/T="Load Error" 0, "You must set something to load!"
		return -1
	endif
	
	SetDataFolder root:
	
	string fFilter = "TIF Images ONLY:.tif,.tiff;",pstr
	variable refNum

	// select files
	Open/MULT=0/D/R/F=fFilter/M="Select a TIFF image stack" refNum
	if (strlen(S_filename)==0)
		return -1
	endif
	
	string fPath, fFullName, theFile, theFirstFile, fnsuffix, fnimg
	string fSlicePrefix, fSliceName, FolderNameList=""
	variable ic, no, nf, ns, nmax, dn
	
	// get path and file names	
	theFile = S_filename
	fPath = ParseFilePath(1,theFile,":",1,0)
	fFullName = ParseFilePath(0,theFile,":",1,0)
	fSlicePrefix = ParseFilePath(3,theFile,":",0,0)
	NewPath/O/Q/Z imgPath, fPath
	
	// get number of images in stack
	KillDataFolder/Z imgTtmp
	NewDataFolder/O/S imgTtmp
	ImageLoad/Q/C=0/T=TIFF/RTIO/P=imgPath theFile
	nmax = V_numImages
	
#ifdef DEBUG
	SetDataFolder ::
#else
	KillDataFolder :
#endif
	
	if (ls.asstack==1)
		// get each file and append to stack
		FolderNameList = T0do_loadstackasstack(fFullName,ls,stnum=no,digits=dn)
	else
		// set the loop parameters
		no = ls.startimage - 1
		ns = ls.stepimage
		
		if (numtype(ls.endimage)!=0)
			nf = nmax
		else
			nf = ns*ls.endimage
		endif
	
		// set the digits for sequencing image names
		dn = ls.startindex + nf*ls.stepindex
		dn = round(log(dn))
		// loop through to load images from stack
		for (ic=no;ic<nf;ic+=ns)
			FolderNameList += T0do_loadfile(fFullName,ls,stnum=ic,digits=dn) + ";"
		endfor
	endif
	
	pstr = f_DateTimeStamp() + " -> Loaded a TIFF image stack from " + fPath
	pstr += "\r\tFile: " + fFullName
	pstr += "\r\tInto Folder(s): " + FolderNameList
	print pstr
	
	return 0
end

// load a file
// fname - file name with extension; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadfile(fname,ls,[stnum,digits])
	string fname
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	variable ne, bd
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()

	// get the folder name prefix
	fnprefix = T0_CleanUpImageFileName(fname)

	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d"
		sprintf fnprefix fs, (ls.startindex + stnum*ls.stepindex)
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF
		
	// load the image file
	
	if (ParamIsDefault(stnum))
		ImageLoad/RAT/P=imgPath/N=source/Q fname
	else
		ImageLoad/RAT/P=imgPath/S=(stnum)/C=1/Q fname
	endif
	
	// clean up file name
	imgname = StringFromList(0,s_wavenames)
	wave source = $imgname
	rename source img_source
	wave img_source
	
	// convert to 8 bit if needed
	bd = f_ImageBitDepth(simgname = "img_source")
	if ((bd == 16) && !ls.allow16bit)
		Redimension/D img_source
		img_source /= 2^8
		Redimension/B/U img_source
	endif
	
	// generate red
	if (ls.red)
		ImageTransform/P=0 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_red
	endif
	
	// generate green
	if (ls.green)
		ImageTransform/P=1 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_green
	endif
	
	// generate blue
	if (ls.blue)
		ImageTransform/P=2 getPlane img_source
		wave M_ImagePlane
		rename M_ImagePlane img_blue
	endif
	
	// generate gray
	if (ls.gray)
		ImageTransform rgb2gray img_source
		wave M_RGB2Gray
		rename M_RGB2Gray img_gray
	endif
	
	// single channel gray already
	if (ls.graw)
		duplicate/O img_source img_gray
		ls.gray = 1
	endif
	
	// keep source?
	if (!ls.source)
		killwaves/Z img_source
	else
		rename img_source imgrawsource
	endif
	
	// store the load parameters and clean up tags
	T0_StoreLoadParams(fname,ls)	
	T0_CleanUpTags()

	SetDataFolder cdf
	return newFldrName
end

// store file load parameters
Function T0_StoreLoadParams(fname,ls)
	string fname
	STRUCT S_LoadSettings &ls
	
	NewDataFolder/O/S imgT_loadparams
	string/G sDateLoaded = f_DateTimeStamp()
	PathInfo imgPath
	string/G sFileName = s_path + fname
	variable/G imgred, imggreen, imgblue, imgsource, imggray, imgstack
	imgred = ls.red
	imggreen = ls.green
	imgblue = ls.blue
	imggray = ls.gray
	imgsource = ls.source
	imgstack = ls.asstack
	
	SetDataFolder ::
	return 0
end

// load list of files as a stack
// fname - folder name
// flist - file name list; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadfilesasstack(fname,flist,ls,[stnum,digits])
	string fname,flist
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	variable ic, nChunks, bd
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()

	fnprefix = "imgT_" + CleanUpName(fname,0)
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d_stack"
		sprintf fnprefix fs, ls.startindex
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF

	// load the first file and set the file to load images
	nChunks = ItemsInList(flist)
	fname = StringFromList(0,flist)
	ImageLoad/RTIO/P=imgPath/Q fname
	ImageLoad/P=imgPath/Q/N=imgrawsource fname
	wave imgrawsource

	// load each file into a stack
	if (ls.graw)
		Redimension/N=(-1,-1,1) imgrawsource
		for(ic=1;ic<nChunks;ic+=1)
			fname = StringFromList(ic,flist)
			ImageLoad/RTIO/P=imgPath/Q fname
			ImageLoad/P=imgPath/Q/N=imgFile fname
			wave imgFile
			ImageTransform/O/INSW=imgFile/P=(ic) insertZplane imgrawsource
			killwaves/Z imgFile
		endfor	
		// make the source to tmp
		Duplicate/O imgrawsource imgtmp
		wave imgtmp
	else
		Redimension/N=(-1,-1,-1,1) imgrawsource
		for(ic=1;ic<nChunks;ic+=1)
			fname = StringFromList(ic,flist)
			ImageLoad/RTIO/P=imgPath/Q fname
			ImageLoad/P=imgPath/Q/N=imgFile fname
			wave imgFile
			ImageTransform/D=imgFile/CHIX=(ic) insertChunk imgrawsource
			killwaves/Z imgFile
		endfor	
		// make the source to tmp
		Duplicate/O imgrawsource imgtmp
		wave imgtmp
		Redimension/E=1/N=(-1,-1,3*nChunks) imgtmp
		nChunks = nChunks*3 - 1
	endif
			
	// convert to 8 bit if needed
	bd = f_ImageBitDepth(simgname = "imgtmp")
	if ((bd == 16) && !ls.allow16bit)
		Redimension/D imgtmp
		imgtmp /= 2^8
		Redimension/B/U imgtmp
	endif

	// get components
	if (ls.red)
		MatrixOP/O img_red_st = imgtmp[][][0,nChunks,3]
		wave img_red_st
	endif
	if (ls.green)
		MatrixOP/O img_green_st = imgtmp[][][1,nChunks,3]
		wave img_green_st
	endif
	if (ls.blue)
		MatrixOP/O img_blue_st = imgtmp[][][2,nChunks,3]
		wave img_blue_st
	endif
	if (ls.gray)
		ImageTransform rgb2gray imgrawsource
		wave M_RGB2Gray
		MatrixOP/O img_gray_st = M_RGB2gray[][][0,nChunks,3]		
	endif
	
	// single channel gray already
	if (ls.graw)
		duplicate/O imgtmp img_gray_st
		ls.gray = 1
	endif

	// keep source?
	if (!ls.source)
		killwaves/Z imgrawsource, imgtmp
	else
		killwaves/Z imgrawsource
		rename imgtmp imgrawsource
	endif
	
	// store the load parameters and clean up tags
	T0_StoreLoadParams(fname,ls)
	T0_CleanUpTags()
	
	SetDataFolder cdf
	return newFldrName
end

// load a stack as a stack
// fname - file name; ls - load settings
// stnum - start number, digits - sequence digits
// returns folder name
Function/S T0do_loadstackasstack(fname,ls,[stnum,digits])
	string fname
	STRUCT S_LoadSettings &ls
	variable stnum, digits

	string fnprefix, newFldrName, imgname, fs
	variable ic, jc, no, ns, nload, nstep, nchunks, bd
	
	// create and move to folder
	DFREF cdf = GetDataFolderDFR()

	fnprefix = T0_CleanUpImageFileName(fname)
	if (!ParamIsDefault(stnum))
		fs =  fnprefix + "_%0" + num2str(digits) + "d_stack"
		sprintf fnprefix fs, ls.startindex
	endif
	newFldrName = CreateImageFolder(fnprefix)
	DFREF imgDF = root:$newFldrName

	SetDataFolder imgDF

	// set up the image loading parameters
	no = ls.startimage
	ns = ls.stepimage
	nload = ls.endimage*ns
	
	ImageLoad/RTIO/P=imgPath/Q fname
	ImageLoad/P=imgPath/S=(nload)/C=(-1)/Q/N=imgrawsource fname
	wave imgrawsource
	nChunks = DimSize(imgrawsource,3)
#ifdef DEBUG
	print "Want to load and actual load: ", nload, nChunks
#endif
	if (ls.endimage == inf)
		nload = nChunks
	endif

	Duplicate/O imgrawsource imgtmp
	wave imgtmp
	Redimension/E=1/N=(-1,-1,3*nChunks) imgtmp

	ns *= 3
	nChunks = nload*ns - 1
			
	// convert to 8 bit if needed
	bd = f_ImageBitDepth(simgname = "imgtmp")
	if ((bd == 16) && !ls.allow16bit)
		Redimension/D imgtmp
		imgtmp /= 2^8
		Redimension/B/U imgtmp
	endif
	
	// get components
	if (ls.red)
		MatrixOP/O img_red_st = imgtmp[][][0,nChunks,ns]
		wave img_red_st
	endif
	if (ls.green)
		MatrixOP/O img_green_st = imgtmp[][][1,nChunks,ns]
		wave img_green_st
	endif
	if (ls.blue)
		MatrixOP/O img_blue_st = imgtmp[][][2,nChunks,ns]
		wave img_blue_st
	endif
	if (ls.gray)
		ImageTransform rgb2gray imgrawsource
		wave M_RGB2Gray
		MatrixOP/O img_gray_st = M_RGB2gray[][][0,nChunks,ns]		
	endif
	
	// single channel gray already
	if (ls.graw)
		duplicate/O imgtmp img_gray_st
		ls.gray = 1
	endif

	// keep source?
	if (!ls.source)
		killwaves/Z imgrawsource, imgtmp
	else
		killwaves/Z imgrawsource
		rename imgtmp imgrawsource
	endif
	
	// store the load parameters and clean up tags
	T0_StoreLoadParams(fname, ls)
	T0_CleanUpTags()
	
	SetDataFolder cdf
	return newFldrName
end

// create a folder to store an image
Function/S CreateImageFolder(fname)
	string fname
	
	SetDataFolder root:
	
	// create the new data folder and subfolder
	variable ic = 0, etrue = 1
	do
		if (DataFolderExists(fname))
			fname = fname + num2str(ic)
		else
			etrue = 0
		endif
	while(etrue)
	NewDataFolder/S $fname
	
	SetDataFolder root:
	
	return fname
end

// clean up the file name
Function/S T0_CleanUpImageFileName(fn)
	string fn
	
	variable ne
	string rstr
	// remove file name prefix
	ne = ItemsInList(fn,".") - 1
	// remove file ending
	fn = RemoveListItem(ne,fn,".")
	// zap periods
	fn = ReplaceString(".",fn,"")
	// zap extra spaces
	rstr = ReplaceString("  ",fn," ")
	// add prefix
	rstr = "imgT_" + cleanupname(rstr,0)
	return rstr
end

// checkbox procedure
Function X_SetLoad(cba) : CheckBoxControl
	STRUCT WMCheckboxAction &cba

	switch( cba.eventCode )
		case 2: // mouse up			
			STRUCT S_LoadSettings ls
			Sf_GetLoadSettings(ls)			
			if (ls.howmany == 0)
				Button buttonLoad_tab0, win=$k_fullpanel, disable=2
				Checkbox checkgred_tab0, win=$k_fullpanel, disable=0
				Checkbox checkggreen_tab0, win=$k_fullpanel, disable=0
				Checkbox checkgblue_tab0, win=$k_fullpanel, disable=0
				Checkbox checkggray_tab0, win=$k_fullpanel, disable=0
				Checkbox checkgraw_tab0, win=$k_fullpanel, disable=0
			else
				Button buttonLoad_tab0, win=$k_fullpanel, disable=0
				if (ls.channels == 1)
					Checkbox checkgred_tab0, win=$k_fullpanel, value=0, disable=2
					Checkbox checkggreen_tab0, win=$k_fullpanel, value=0, disable=2
					Checkbox checkgblue_tab0, win=$k_fullpanel, value=0, disable=2
					Checkbox checkggray_tab0, win=$k_fullpanel, value=0, disable=2
					Checkbox checkgraw_tab0, win=$k_fullpanel, disable=0
				else
					Checkbox checkgred_tab0, win=$k_fullpanel, disable=0
					Checkbox checkggreen_tab0, win=$k_fullpanel, disable=0
					Checkbox checkgblue_tab0, win=$k_fullpanel, disable=0
					Checkbox checkggray_tab0, win=$k_fullpanel, disable=0
					Checkbox checkgraw_tab0, win=$k_fullpanel, value=0, disable=2
				endif
			endif
			
			break
	endswitch
	
	return 0
end

// choose folders for conversion
Function T0_ConvertDataFolders()
	
	STRUCT S_LoadSettings ls
	variable asStack

	SetDataFolder root:
	
	CreateBrowser/M prompt="Choose root data folders to convert to formats readable by Image Tools"
	ModifyBrowser/M showwaves=0, showvars=0, showstrs=0, executeMode=2, showInfo=0, showPlot=0
	ModifyBrowser/M showModalBrowser
	
	if (v_flag == 1)
		Sf_GetLoadSettings(ls)
		imgT_doConversion(S_BrowserList,ls.asStack)
	endif

	return 0
end

// convert folders
Function imgT_doConversion(fldrList,asStack)
	string fldrList
	variable asStack
	
	variable ic, jc, nfldrs, nimgs, nTimgs, tas
	string theFldr, theImgList, theImg, theNName, strLoad
	
	nfldrs = ItemsInList(fldrList)
	fldrList = ReplaceString("root:",fldrList,"")
	fldrList = ReplaceString(":",fldrList,"")
	fldrList = SortList(fldrList)
	for (ic=0;ic<nfldrs;ic+=1)
		theFldr = StringFromList(ic,fldrList)
		DuplicateDataFolder/O=1 $theFldr, imgT_tmp
		SetDataFolder imgT_tmp
		theImgList = SortList(WaveList("*",";","DIMS:2"))
		nimgs = ItemsInList(theImgList)
		if (nimgs < 4)
			tas = 0
		else
			tas = asStack
		endif
		for (jc=0;jc<nimgs;jc+=1)
			theImg = StringFromList(jc,theImgList)
			if (tas)
				if (jc==0)
					theNName = "img_" + CleanUpName(theImg,0) + "_st"
					Rename $theImg $theNName
					wave simg = $theNName
					redimension/N=(-1,-1,nimgs) simg
				else
					wave snimg = $theImg
					ImageTransform/O/D=snimg/P=(jc) setPlane simg
					killwaves/Z snimg
				endif
			else
				theNName = "img_"+CleanUpName(theImg,0)
				Rename $theImg $theNName
			endif
		endfor
		nTimgs += nimgs
		SetDataFolder ::
		theNName = "imgT_" + CleanUpName(theFldr,0)
		RenameDataFolder imgT_tmp $theNName
	endfor
	
	sprintf strLoad, "%s -> Converted %d folders and %d images", f_DateTimeStamp(), nfldrs, nTimgs
	strLoad += "\r\tFolders: " + fldrList
	print strLoad
	
	return 0
end